
\documentclass{article}

\usepackage[scaled=0.8]{beramono} % ttfamily font
\usepackage{caption} % For longlisting environment defined below
\usepackage{etoolbox}
\usepackage{mdframed}
\usepackage{minted}
\usepackage[T1]{fontenc}
\usepackage{xcolor}

% This  option is for fancy boxes
% 
%\usepackage{tcolorbox}
%\usepackage{etoolbox}
%\BeforeBeginEnvironment{minted}{\begin{tcolorbox}}%
%\AfterEndEnvironment{minted}{\end{tcolorbox}}%

\pagestyle{plain}

\title{Latex Minted Eclipse Style}
\date{}
\author{Mark Royer}

% FROM: https://tex.stackexchange.com/questions/368864/pagebreak-for-minted-in-figure
% Create a new environment for breaking code listings across pages.
\newenvironment{longlisting}{\captionsetup{type=listing}}{}

% Default minted settings
\setminted[javae]{
  % javaelexer.py (javae) must be in pygments/lexers directory and registered
  % using pygments/lexers/_mapping.py
  breaklines=true,
  frame=single,  
  linenos=true,
  style=eclipse, % eclipse.py must be in pygments/styles directory
  xleftmargin=2.5em,
  xrightmargin=0em,
}

% Set the line number color
\renewcommand\theFancyVerbLine{\color{gray}\arabic{FancyVerbLine}}

\begin{document}

% For standard modern computer teletype font use
%
% \fontfamily{lmtt}\selectfont
%
% in the document.  Surround with {} to limit scope.  For example,
%
% {\fontfamily{lmtt}\selectfont I'm using modern computer teletype},
% \texttt{but I'm beramono set in usepackage}



\abstract

The following document is an example of using a custom minted style.
Please look at the following examples of how to use the style
file. The default style is set to eclipse, and the default language is
Java.  These are set at the end of the \texttt{.sty} file.

\section*{Listing Inline}

% So we don't create weird spacing for single words.
\setminted{breaklines=false}

You can use the \texttt{\textbackslash mintinline\{javae\}|command|} to use the custom
Java extended lexer and eclipse style in paragraphs.  The 8 basic types in Java are
\mintinline{javae}|boolean|, \mintinline{javae}|byte|, \mintinline{javae}|char|,
\mintinline{javae}|short|, \mintinline{javae}|int|, \mintinline{javae}|long|,
\mintinline{javae}|float|, and \mintinline{javae}|double|. These should have been
properly formatted in the previous sentence.

% Make sure to break lines the rest of the document
\setminted{breaklines=true}

\section*{Block Listing Example}

A slightly longer block example is shown in listing \ref{lst:simple}.




\begin{listing}[H]
% Java and javadoc language lexer
\begin{minted}[]{javae}
  /**
    * @param args
    *             Program arguments
    */
  public static void main(String[] args) {
    // Now for the enlightening message.
    System.out.println("Hmm... hello big world!";
    // TODO Finish this example
    // Just some comment that is probably too long to fit in the space provided....
  }
\end{minted}
\caption{A simple listing.}
\label{lst:simple}
\end{listing}

\section*{File Listing Example}

An example that includes a \texttt{.java} file is shown in listing \ref{lst:file}.

\begin{longlisting}
  \inputminted[breaklines=true,linenos=true,frame=single,xleftmargin=0em]{javae}{Rectangle.java}
  \caption{A listing from the file \texttt{Rectangle.java}}
  \label{lst:file}
\end{longlisting}

\section*{Further Customizations}

Sometimes you just have to do things yourself.  If you really want to
make custom changes inside code, then you escape and use standard
\LaTeX\ as shown below.  For example, the enum below has no color or
emphasis as is typical in Eclipse. 

\begin{listing}[H]
\begin{minted}{javae}
  enum {
    FIRST,
    SECOND,
    THIRD
  }
\end{minted}
\caption{Without manual customizations.}
\label{lst:nocustom}
\end{listing}


You may add your own latex by escaping out of the listing.  I've added
two macros to mimic Eclipse field (\texttt{\textbackslash ef}) and
Eclipse field italicized (\texttt{\textbackslash efi}).  There is also
a similar \texttt{\textbackslash ecom} and \texttt{\textbackslash
  ecomi} for comment styling. The results are shown below.

\definecolor{fieldColor}{rgb}{0.16,0.00,1.00}
\definecolor{commentColor}{rgb}{0.25,0.50,0.37}

% For manual eclipse field styling
\newrobustcmd{\ef}[1]{%
{\color{fieldColor}\ttfamily#1}%
}
\newrobustcmd{\efi}[1]{%
{\color{fieldColor}\it\ttfamily#1}%
}

% For manual eclipse comment styling
\newrobustcmd{\ecom}[1]{%
{\color{commentColor}\ttfamily#1}%
}
\newrobustcmd{\ecomi}[1]{%
{\color{commentColor}\it\ttfamily#1}%
}


\begin{listing}[H]
\begin{minted}[escapeinside=||]{javae}
  enum {
    |\efi{FIRST}|,
    |\efi{SECOND}|,
    |\efi{THIRD}|
  }
\end{minted}
\caption{With manual customizations.}
\label{lst:custom}
\end{listing}



The nice thing about this approach is that you can use anything that
you normally can in \LaTeX.  For example,


\begin{listing}[H]
\begin{minted}[escapeinside=||]{javae}
  enum {
    |\efi{$\alpha$}|,
    |\efi{$\beta$}|,
    |\efi{$\gamma$}|,
    |\efi{$e$}| // |\ecom{$\lim_{n\to\infty}{\left( 1 + \frac{1}{n} \right)^n}$}|
  }
\end{minted}
\caption{Something a little different.}
\label{lst:wacky}
\end{listing}

\noindent
makes heavy use of the math environment. Of course, some of the lines
are a little too big, so the bounding box appears slightly broken.


\end{document}


% LocalWords:  lstcustom listinline boolean Customizations enum ef
% LocalWords:  efi ecom ecomi
